Bug 43527

Summary: ICE in cselib_record_set, at cselib.c:1864 during build of compiler
Product: gcc Reporter: Joel Sherrill <joel>
Component: targetAssignee: Not yet assigned to anyone <unassigned>
Status: RESOLVED FIXED    
Severity: normal CC: gcc-bugs
Priority: P3    
Version: 4.5.0   
Target Milestone: ---   
Host: Target: lm32-rtems4.10
Build: Known to work:
Known to fail: Last reconfirmed:

Description Joel Sherrill 2010-03-25 21:33:45 UTC
This worked in 4.4.x with the lm32 patch before merger.

GNU C (GCC) version 4.5.0 20100316 (experimental) [trunk revision 157481] (lm32-rtems4.10)
	compiled by GNU C version 4.5.0 20100316 (experimental) [trunk revision 157481], GMP version 4.3.1, MPFR version 2.4.1, MPC version 0.8

/users/joel/test-gcc/b-gcc1-lm32/./gcc/xgcc -B/users/joel/test-gcc/b-gcc1-lm32/./gcc/ -nostdinc -B/users/joel/test-gcc/b-gcc1-lm32/lm32-rtems4.10/newlib/ -isystem /users/joel/test-gcc/b-gcc1-lm32/lm32-rtems4.10/newlib/targ-include -isystem /users/joel/test-gcc/gcc-svn/newlib/libc/include -B/usr/local/lm32-rtems4.10/bin/ -B/usr/local/lm32-rtems4.10/lib/ -isystem /usr/local/lm32-rtems4.10/include -isystem /usr/local/lm32-rtems4.10/sys-include    -g -O2 -O2 -I../../gcc-svn/gcc/../newlib/libc/sys/rtems/include -g -O2 -DIN_GCC -DCROSS_DIRECTORY_STRUCTURE  -W -Wall -Wwrite-strings -Wcast-qual -Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition  -isystem ./include   -g  -DIN_LIBGCC2 -D__GCC_FLOAT_NOT_NEEDED -Dinhibit_libc -G 0 -msign-extend-enabled -I. -I. -I../.././gcc -I../../../gcc-svn/libgcc -I../../../gcc-svn/libgcc/. -I../../../gcc-svn/libgcc/../gcc -I../../../gcc-svn/libgcc/../include  -DHAVE_CC_TLS -o _muldc3.o -MT _muldc3.o -MD -MP -MF _muldc3.dep -DL_muldc3 -c ../../../gcc-svn/libgcc/../gcc/libgcc2.c 
../../../gcc-svn/libgcc/../gcc/libgcc2.c: In function ‘__muldc3’:
../../../gcc-svn/libgcc/../gcc/libgcc2.c:1889:1: internal compiler error: in cselib_record_set, at cselib.c:1864
Please submit a full bug report,
with preprocessed source if appropriate.
See <http://gcc.gnu.org/bugs.html> for instructions.
Comment 1 Joel Sherrill 2010-03-25 21:36:02 UTC
Compiles at -O0.

Fails at -O1.

Suggestions on an optimization pass to disable is welcomed.
Comment 2 Jon Beniston 2010-05-25 23:55:25 UTC
Hi Joel, do you have a .i test case for this? Thanks.
Comment 3 Joel Sherrill 2010-05-26 00:26:03 UTC
(In reply to comment #2)
> Hi Joel, do you have a .i test case for this? Thanks.
> 

It works today. with 

$ lm32-rtems4.10-gcc --version
lm32-rtems4.10-gcc (GCC) 4.6.0 20100525 (experimental) [trunk revision 159847]

Do I need to pull the 4.5 branch and try that?
Comment 4 Joel Sherrill 2011-01-25 04:16:31 UTC
The libgcc issue also occurs with lm32-rtems.  Can that much be applied to the trunk?

4.6.0 20110123 (experimental) [trunk revision 169143]
Comment 5 Joel Sherrill 2011-02-08 21:45:34 UTC
4.5.2 builds for lm32 so closing.